
proc read_file {fileName} {
	if {[catch {
		set fd [open $fileName "r"]
		set contents [read $fd]
		close $fd
	} err]} {
		puts stderr $err
		exit 1
	}
	return $contents
}

proc write_file {fileName contents} {
	if {[catch {
		set fd [open $fileName "w"]
		puts -nonewline $fd $contents
		close $fd
	} err]} {
		puts stderr $err
		exit 1
	}
}

proc process_html_file {fileName} {
	set contents [read_file $fileName]

	#--------
	# There seems to be a bug in [string map ...] that occasionally
	# causes a substitution to not be performed if it immediately
	# follows another substitution that was performed. I work around
	# this by calling [string map ...] twice.
	#--------
	set map_list [list \
		"</PRE><BR>\n<BR>\n"                  "</PRE>\n" \
		"<BR>\n<BR>\n\n<DIV CLASS=\"center\">" \
						"\n<DIV CLASS=\"center\">" \
		{<DIV CLASS="center"><HR WIDTH="80%" SIZE=2></DIV>} "" \
		"<BR>\n<BR>\n<!--TOC"                 "\n\n<!--TOC" \
		"</DIV><BR>\n<BR>\n<A"                 "</DIV>\n<A" \
		"<BR>\n<BR>\n<A NAME=\"@default"       "\n<A NAME=\"@default" \
		".png\"></DIV>\n\t\t<BR>\n<BR>\n<DIV CLASS=\"center\"" \
				".png\"></DIV>\n<BR>\n<DIV CLASS=\"center\"" \
		".png\"></DIV>\n\t<BR>\n<BR>\n<DIV CLASS=\"center\"" \
				".png\"></DIV>\n<BR>\n<DIV CLASS=\"center\"" \
		".png\"></DIV>\n<BR>\n<BR>\n<DIV CLASS=\"center\"" \
				".png\"></DIV>\n<BR>\n<DIV CLASS=\"center\"" \
		"<BR>\n<BR>\n<LI"                     "\n<LI" \
	]
	set contents [string map $map_list $contents]
	set contents [string map $map_list $contents]

	write_file $fileName $contents
}

#--------
# Mainline
#--------
foreach fileName $argv {
	puts "Processing $fileName..."
	process_html_file $fileName
}
